package pl.hycom.phoenix;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class ForwardingServlet
 */
public abstract class DispatchingServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public DispatchingServlet() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher requestDispatcher = getDispatcher(request);
		doDispatch(requestDispatcher, request, response);
	}

	private RequestDispatcher getDispatcher(HttpServletRequest request) {
		String context = request.getParameter("context");
		String path = request.getParameter("path");
		
		ServletContext ctx = request.getServletContext().getContext(context);
		return ctx.getRequestDispatcher(path);
	}

	protected abstract void doDispatch(RequestDispatcher requestDispatcher, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException;
	
}
